<!DOCTYPE html>
<html dir="ltr" lang="ru-RU">
<head>
 <meta charset="utf-8">
 <title>Сервис для онлайн-проверки регулярных выражений</title>
 <link rel="stylesheet" href="regexp.css">
 <script type="text/javascript" src="jquery.js"></script>
</head>
<body>

<div id="content">

 <script type="text/javascript">
  var state = 0;
  var previousRegexp = '';
  var previousModifier = '';
  var previousStrings = '';
    
  function updateMe() {
   form = $('#mainform');
   params = form.serialize();
   action = mainform.action;
   $.post(action, params, function(data) {
    $('#result').html(data);
   });
  }
    
  function checkMe() {
   if (strings.value !== previousStrings || 
       regexp.value !== previousRegexp || 
       modificator.value !== previousModifier) {
    state = 1;
    previousStrings = strings.value;
    previousRegexp = regexp.value;
    previousModifier = modificator.value;
   }
   if (state == 1) state = 2;
   else if (state == 2) {
    state = 0;
    updateMe();
   }  
  }
    
  $ (function () {
   document.getElementById('regexp').value = '';
   checkMe();
   setInterval('checkMe()', 350);
  });
 </script>
 <noscript>Извините, для работы приложения нужен включённый Javascript</noscript>
   
 <form id="mainform" action="action.php" method="post" target="result">
  <p>Регулярка
   <span>"/</span>
   <input id="regexp" name="regexp" size="80" value="" />
   <span>/</span>
   <input id="modificator" name="modificator" size="6" maxlength="5" value="u" />
   " с модификаторами
  </p>    
  <table>
   <tr>
    <td valign="top">
     <p>Выражения (по одному в строке)</p>
    </td>
    <td valign="top">
     <p>Результаты для preg_match, совпадения <span class="matched">подсвечены</span></p>
    </td>
   </tr>
   <tr>
    <td valign="top">
     <textarea id="strings" name="strings" cols="55" rows="10" maxlength="10000"></textarea>
    </td>
    <td valign="top">
     <div id="result"></div>
    </td>
   </tr>
  </table>
 </form>
   
 <div id="help">
  <table>
   <tr>
    <td colspan="8" align="center">Символьные классы и специальные символы</td>
   </tr>
   <tr>
    <td>[abc]</td><td>Любой из a, b, c</td>
    <td>[^abc]</td><td>Любой, кроме a, b, c</td>
    <td>[a-z]</td><td>Любой из диапазона</td>
    <td>[a-zА-Я]</td><td>Любой из диапазонов</td>
   </tr>
   <tr>
    <td>.</td><td>Любой символ</td>
    <td>\.</td><td>Символ точки</td>
    <td>\\</td><td>Символ "обратный слэш"</td>
    <td>&nbsp;</td><td>&nbsp;</td>
   </tr>
   <tr>
    <td>( )</td><td>Подшаблон</td>
    <td>(a|b)</td><td>Выбор a или b в подшаблоне</td>
    <td>&nbsp;</td><td>&nbsp;</td>
    <td>&nbsp;</td><td>&nbsp;</td>
   </tr>
   <tr>
    <td>^</td><td>Начало строки</td>
    <td>$</td><td>Конец строки</td>
    <td>\A</td><td>Начало текста</td>
    <td>\z</td><td>Конец текста</td>
   </tr>
   <tr>
    <td>\s</td><td>Пробельный символ</td>
    <td>\S</td><td>Не пробельный символ</td>
    <td>\n</td><td>Новая строка Unix</td>
    <td>\r\n</td><td>Новая строка Windows</td>
   </tr>
   <tr>
    <td>\b</td><td>Граница слова (начало/конец)</td>
    <td>\t</td><td>Табуляция</td>
    <td>\d</td><td>Цифра 0-9</td>
    <td>\D</td><td>Не цифра</td>
   </tr>
   <tr>
    <td>\w</td><td>Буква (включая цифры и подчёркивание)</td>
    <td>\W</td><td>Не буква (специальный символ)</td>
    <td>\pL</td><td>Буква в utf-8, с модификатором u</td>
    <td>&nbsp;</td><td>&nbsp;</td>
   <tr>
    <td colspan="8" align="center">Квантификаторы</td>
   </tr>
    <td>x?</td><td>Один x или пусто</td>
    <td>x*</td><td>Ноль и более x</td>
    <td>x+</td><td>Один и более x</td>
    <td>x{3}</td><td>x ровно 3 раза</td>
   </tr>
   <tr>
    <td>x{3,}</td><td>x 3 и более раз</td>
    <td>x{3,5}</td><td>x от 3 до 5 раз</td>
    <td>&nbsp;</td><td>&nbsp;</td>
    <td>&nbsp;</td><td>&nbsp;</td>
   </tr>
   <tr>
   <tr>
    <td colspan="8" align="center">Модификаторы</td>
   </tr>
    <tr>
     <td>i</td><td>Поиск не зависит от регистра. "/x/i" ищет и x, и X.</td>
     <td>U</td><td>Не жадный (ищущий минимальное соответствие) поиск </td>
     <td>u</td><td>Искать в Юникоде (utf-8)</td>
     <td>m</td><td>Искать в многострочном тексте</td>
   </tr>
   <tr>
     <td>s</td><td>Точка соответствует также переводу строки</td>
     <td>x</td><td>Игнорировать пробелы (в этом случае они экранируются обратным слэшем \)</td>
     <td>&nbsp;</td><td>&nbsp;</td>
     <td>&nbsp;</td><td>&nbsp;</td>
    </tr>
  </table>
 </div>

</div>

</body>
</html>